import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import React, { Fragment } from 'react';
import purebem from 'purebem';
import { FoundationDropdown } from '@billogram/foundation-dropdown';
import { pgettext } from '@billogram/lang';
import FoundationTableHeader from './header/FoundationTableHeader';
import { FoundationTableRowProvider } from './row/FoundationTableRowContext';
import FoundationTableFetchMoreButtons from './FoundationTableFetchMoreButtons';
import FoundationTableSpinner from './FoundationTableSpinner';
import FoundationTableState from './FoundationTableState';
import getDropdownSortOptions from './getDropdownSortOptions';
import './FoundationTable.scss';

function noop() {}

export default function FoundationTable(_ref) {
  var additionalRowData = _ref.additionalRowData,
      _ref$columns = _ref.columns,
      columns = _ref$columns === void 0 ? [] : _ref$columns,
      _ref$EmptyState = _ref.EmptyState,
      EmptyState = _ref$EmptyState === void 0 ? function () {
    return React.createElement(FoundationTableState, {
      description: pgettext('foundation-table', 'EmptyState--description'),
      title: pgettext('foundation-table', 'EmptyState--title')
    });
  } : _ref$EmptyState,
      _ref$fetchInitial = _ref.fetchInitial,
      fetchInitial = _ref$fetchInitial === void 0 ?
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee() {
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })) : _ref$fetchInitial,
      _ref$fetchMore = _ref.fetchMore,
      fetchMore = _ref$fetchMore === void 0 ?
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee2() {
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })) : _ref$fetchMore,
      _ref$fetchSort = _ref.fetchSort,
      fetchSort = _ref$fetchSort === void 0 ?
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee3() {
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })) : _ref$fetchSort,
      _ref$isSearchResult = _ref.isSearchResult,
      isSearchResult = _ref$isSearchResult === void 0 ? false : _ref$isSearchResult,
      _ref$removeItem = _ref.removeItem,
      removeItem = _ref$removeItem === void 0 ? noop : _ref$removeItem,
      searchFields = _ref.searchFields,
      _ref$searchTerms = _ref.searchTerms,
      searchTerms = _ref$searchTerms === void 0 ? [] : _ref$searchTerms,
      _ref$subTitle = _ref.subTitle,
      subTitle = _ref$subTitle === void 0 ? '' : _ref$subTitle,
      table = _ref.table,
      _ref$tableName = _ref.tableName,
      tableName = _ref$tableName === void 0 ? void 0 : _ref$tableName,
      _ref$TableRow = _ref.TableRow,
      TableRow = _ref$TableRow === void 0 ? function () {
    return null;
  } : _ref$TableRow,
      TableRowExpandResultGroup = _ref.TableRowExpandResultGroup,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title,
      _ref$titleFilter = _ref.titleFilter,
      titleFilter = _ref$titleFilter === void 0 ? '' : _ref$titleFilter,
      _ref$updateItem = _ref.updateItem,
      updateItem = _ref$updateItem === void 0 ? noop : _ref$updateItem;

  switch (table.state) {
    case 'error-initial':
    case 'error-more':
    case 'error-sort':
      {
        return React.createElement(FoundationTableState, {
          description: pgettext('foundation-table', 'ErrorState--description'),
          title: pgettext('foundation-table', 'ErrorState--title'),
          ui: "error"
        });
      }

    case 'fetching-initial':
      {
        return React.createElement(FoundationTableSpinner, null);
      }

    case 'fetching-more':
    case 'fetching-sort':
    case 'success':
      {
        var isFetchingMore = table.state === 'fetching-more';
        var isFetchingSort = table.state === 'fetching-sort';
        var isFetching = isFetchingMore || isFetchingSort;

        if (table.data.items.length === 0) {
          return React.createElement(EmptyState, null);
        }

        var tableTitleFilter = titleFilter !== '' && titleFilter !== void 0 && table.data.totalCount > 0 ? "".concat(titleFilter, " (").concat(table.data.totalCount, ")") : titleFilter;
        var tableTitleMain = tableTitleFilter === '' && title !== '' && title !== void 0 && table.data.totalCount > 0 ? "".concat(title, " (").concat(table.data.totalCount, ")") : title;
        var dropdownSortOptions = getDropdownSortOptions(columns, table.meta.sortBy, table.meta.sortDirection);
        var block = purebem('foundation-table');
        return React.createElement(Fragment, null, React.createElement("table", {
          className: block(),
          "data-table-name": tableName
        }, React.createElement("caption", {
          className: block('caption')
        }, tableTitleFilter !== '' || tableTitleMain !== '' ? React.createElement("div", {
          className: block('caption-title')
        }, tableTitleFilter !== '' ? React.createElement("div", {
          className: block('caption-title-filter')
        }, tableTitleFilter) : null, tableTitleMain !== '' ? React.createElement("div", {
          className: block('caption-title-main', {
            withFilterTitle: tableTitleFilter !== ''
          })
        }, tableTitleMain) : null) : null, subTitle !== '' ? React.createElement("div", {
          className: block('caption-sub-title')
        }, subTitle) : null, dropdownSortOptions.length > 0 ? React.createElement("div", {
          className: block('caption-sort-dropdown')
        }, React.createElement(FoundationDropdown, {
          disabled: isFetching,
          onChange: isFetching ? noop : fetchSort,
          options: dropdownSortOptions,
          value: table.meta.sortBy
        })) : null), React.createElement(FoundationTableHeader, {
          columns: columns,
          currentSortBy: table.meta.sortBy,
          currentSortDirection: table.meta.sortDirection,
          isFetching: isFetching,
          shouldDisableSorting: isSearchResult,
          sort: isFetching ? noop : fetchSort
        }), [].map.call(table.data.items, function (item, index, array) {
          return React.createElement(FoundationTableRowProvider, {
            additionalData: additionalRowData,
            columns: columns,
            fetchInitial: fetchInitial,
            key: item.id,
            isFetching: isFetching,
            isLast: index === array.length - 1,
            isOdd: (index + 1) % 2 === 1,
            isSearchResult: isSearchResult,
            item: item,
            removeItem: removeItem,
            searchFields: searchFields,
            searchTerms: searchTerms,
            TableRow: TableRow,
            TableRowExpandResultGroup: TableRowExpandResultGroup,
            updateItem: updateItem
          });
        })), React.createElement(FoundationTableFetchMoreButtons, {
          fetchMore: fetchMore,
          isFetching: isFetching,
          itemsLeftToFetch: table.data.totalCount - table.data.items.length
        }));
      }
  }
}
//# sourceMappingURL=FoundationTable.js.map