import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from 'react';
import purebem from 'purebem';
import { FoundationButton } from '@billogram/foundation-button';
import { FoundationControl, FoundationControlGroup } from '@billogram/foundation-control-group';
import { pgettext } from '@billogram/lang';
import './FoundationTableFetchMoreButtons.scss';
export default function FoundationTableFetchMoreButtons(_ref) {
  var fetchMore = _ref.fetchMore,
      isFetching = _ref.isFetching,
      itemsLeftToFetch = _ref.itemsLeftToFetch;

  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      fetchingMoreLimit = _useState2[0],
      setFetchingMoreLimit = _useState2[1];

  if (!isFetching && fetchingMoreLimit !== 0) {
    setFetchingMoreLimit(0);
  }

  function fetch(limit) {
    return function onClick() {
      setFetchingMoreLimit(limit);
      fetchMore(limit);
    };
  }

  var block = purebem('foundation-table-fetch-more-buttons');
  return React.createElement("div", {
    className: block()
  }, React.createElement(FoundationControlGroup, {
    column: "mobile"
  }, itemsLeftToFetch > 0 ? React.createElement(FoundationControl, null, React.createElement(FoundationButton, {
    disabled: isFetching && fetchingMoreLimit !== 10,
    loading: isFetching && fetchingMoreLimit === 10,
    onClick: fetch(10)
  }, pgettext('foundation-table', 'show-more[%(limit)s]', {
    limit: '10'
  }))) : null, itemsLeftToFetch > 10 ? React.createElement(FoundationControl, {
    devices: ['desktop']
  }, React.createElement(FoundationButton, {
    disabled: isFetching && fetchingMoreLimit !== 100,
    loading: isFetching && fetchingMoreLimit === 100,
    onClick: fetch(100)
  }, pgettext('foundation-table', 'show-more[%(limit)s]', {
    limit: '100'
  }))) : null, itemsLeftToFetch > 100 ? React.createElement(FoundationControl, {
    devices: ['desktop']
  }, React.createElement(FoundationButton, {
    disabled: isFetching && fetchingMoreLimit !== 1000,
    loading: isFetching && fetchingMoreLimit === 1000,
    onClick: fetch(1000)
  }, pgettext('foundation-table', 'show-more[%(limit)s]', {
    limit: '1000'
  }))) : null));
}
//# sourceMappingURL=FoundationTableFetchMoreButtons.js.map