import React from 'react';
import purebem from 'purebem';
import FoundationTableHeaderRow from './FoundationTableHeaderRow';
import FoundationTableHeaderCell from './FoundationTableHeaderCell';
import './FoundationTableHeader.scss';
export default function FoundationTableHeader(_ref) {
  var columns = _ref.columns,
      currentSortBy = _ref.currentSortBy,
      currentSortDirection = _ref.currentSortDirection,
      isFetching = _ref.isFetching,
      shouldDisableSorting = _ref.shouldDisableSorting,
      sort = _ref.sort;
  var block = purebem('foundation-table-header');
  return React.createElement(FoundationTableHeaderRow, null, [].map.call(columns, function (column) {
    return React.createElement(FoundationTableHeaderCell, {
      key: column.name,
      columnName: column.name,
      currentSortBy: currentSortBy,
      currentSortDirection: currentSortDirection,
      hidden: column.hidden,
      isFetching: isFetching,
      shouldDisableSorting: shouldDisableSorting,
      sort: sort,
      sortByColumnKey: column.sortByColumnKey
    }, React.createElement("div", {
      className: block()
    }, React.createElement("div", null, column.title), column.subTitle !== '' && column.subTitle !== null && column.subTitle !== void 0 ? React.createElement("div", {
      className: block('sub-title')
    }, "(", column.subTitle, ")") : null));
  }));
}
//# sourceMappingURL=FoundationTableHeader.js.map