import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState } from 'react';
import purebem from 'purebem';
import { FoundationButton } from '@billogram/foundation-button';
import FoundationTableCell from './FoundationTableCell';
import FoundationTableCellSingleControlGroup from './FoundationTableCellSingleControlGroup';
import './FoundationTableCellAsyncButton.scss';

function noop() {}

export default function FoundationTableCellAsyncButton(_ref) {
  var asyncAction = _ref.asyncAction,
      children = _ref.children,
      columnName = _ref.columnName,
      _ref$onAsyncActionSuc = _ref.onAsyncActionSuccess,
      onAsyncActionSuccess = _ref$onAsyncActionSuc === void 0 ? noop : _ref$onAsyncActionSuc,
      _ref$onAsyncActionErr = _ref.onAsyncActionError,
      onAsyncActionError = _ref$onAsyncActionErr === void 0 ? noop : _ref$onAsyncActionErr,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? true : _ref$visible;
  var block = purebem('foundation-table-cell-async-button');

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isFetching = _useState2[0],
      setIsFetching = _useState2[1];

  function onClick() {
    return _onClick.apply(this, arguments);
  }

  function _onClick() {
    _onClick = _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee() {
      var data;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              setIsFetching(true);
              _context.next = 4;
              return asyncAction();

            case 4:
              data = _context.sent;
              setIsFetching(false);
              onAsyncActionSuccess(data);
              _context.next = 13;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](0);
              setIsFetching(false);
              onAsyncActionError(_context.t0);

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 9]]);
    }));
    return _onClick.apply(this, arguments);
  }

  return React.createElement(FoundationTableCell, {
    columnName: columnName
  }, React.createElement(FoundationTableCellSingleControlGroup, null, React.createElement("div", {
    className: block({
      hidden: !visible
    })
  }, React.createElement(FoundationButton, {
    onClick: onClick,
    loading: isFetching
  }, children))));
}
//# sourceMappingURL=FoundationTableCellAsyncButton.js.map