import React from 'react';
import purebem from 'purebem';
import { FoundationLinkButton } from '@billogram/foundation-button';
import { pgettext } from '@billogram/lang';
import FoundationTableCell from './FoundationTableCell';
import './FoundationTableCellLinkButton.scss';
export default function FoundationTableCellLinkButton(_ref) {
  var columnName = _ref.columnName,
      href = _ref.href,
      ui = _ref.ui;
  var block = purebem('foundation-table-cell-link-button');
  return React.createElement(FoundationTableCell, {
    columnName: columnName
  }, React.createElement("div", {
    className: block('button')
  }, React.createElement(FoundationLinkButton, {
    href: href
  }, pgettext('foundation-table', "Button--".concat(ui)))), React.createElement("a", {
    className: block('icon', {
      ui: ui
    }),
    href: href
  }));
}
//# sourceMappingURL=FoundationTableCellLinkButton.js.map