import React from 'react';
import purebem from 'purebem';
import { Link } from 'react-router';
import { pgettext } from '@billogram/lang';
import { FoundationRouteButton } from '@billogram/foundation-route-button';
import FoundationTableCell from './FoundationTableCell';
import './FoundationTableCellRouteButton.scss';
export default function FoundationTableCellRouteButton(_ref) {
  var columnName = _ref.columnName,
      to = _ref.to,
      ui = _ref.ui;
  var block = purebem('foundation-table-cell-route-button');
  return React.createElement(FoundationTableCell, {
    columnName: columnName
  }, React.createElement("div", {
    className: block('button')
  }, React.createElement(FoundationRouteButton, {
    to: to
  }, pgettext('foundation-table', "Button--".concat(ui)))), React.createElement(Link // eslint-disable-next-line react/forbid-component-props
  , {
    className: block('icon', {
      ui: ui
    }),
    to: to
  }));
}
//# sourceMappingURL=FoundationTableCellRouteButton.js.map