export default function getRanges(value, matchingTerms) {
  var ranges = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = matchingTerms[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var matchingTerm = _step.value;
      var start = value.toLowerCase().indexOf(matchingTerm.toLowerCase(), 0);

      while (start >= 0) {
        var end = start + matchingTerm.length;
        ranges.push([start, end]);
        start = value.toLowerCase().indexOf(matchingTerm.toLowerCase(), end);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return ranges;
}
//# sourceMappingURL=getRanges.js.map