import lodash from 'lodash';
import { formatDatetime, formatMoney } from '@billogram/format';
export default function createMatchesValue(value, type) {
  return function matchesValue(term) {
    switch (type) {
      case 'date':
        {
          return formatDatetime(Number(term)) === formatDatetime(Number(value));
        }

      case 'money':
        {
          var amount = value;
          return amount.value !== null && amount.value !== void 0 && formatMoney(term) === formatMoney(amount.value);
        }

      default:
        {
          var re = new RegExp(lodash.escapeRegExp(term), 'i');
          return re.test(value);
        }
    }
  };
}
//# sourceMappingURL=createMatchesValue.js.map